//---------------------------------------------------------------------------
#ifndef InternalFormH
#define InternalFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
//                   0           1           2             3           4              5               6                  7                  8                9                 10
enum TCentreType    {TAbsolute , TCP1      , TP1C        , TCP2      , TP2C          };
enum TFitType       {TFitNone  , TFitClose , TFitMedium  , TFitFree  };
enum TThreadDir     {TRightHand, TLeftHand };

class TIntForm : public TForm
{
__published:	// IDE-managed Components
    TMainMenu *MainMenu1;
    TMenuItem *File1;
    TMenuItem *Save1;
    TMenuItem *N1;
    TMenuItem *Exit1;
    TMenuItem *Edit1;
    TMenuItem *Copy1;
    TImageList *ImageList1;
    TMenuItem *Help1;
    TMenuItem *Help2;
    TMemo *Memo1;
    TSaveDialog *SaveDialog1;
    TGroupBox *GroupBox1;
    TLabel *Label1;
    TEdit *toolDEdit;
    TLabel *Label2;
    TEdit *toolD1Edit;
    TMenuItem *SelectAll1;
    TMenuItem *N2;
    TEdit *toolLEdit;
    TLabel *Label3;
    TEdit *toolL1Edit;
    TLabel *Label4;
    TImage *Image1;
    TGroupBox *GroupBox2;
    TImage *Image2;
    TImage *Image3;
    TEdit *FEdit;
    TLabel *Label5;
    TEdit *toolNEdit;
    TLabel *Label6;
    TLabel *Label7;
    TLabel *Label8;
    TLabel *Label9;
    TLabel *Label10;
    TEdit *CXEdit;
    TEdit *CYEdit;
    TEdit *CZEdit;
    TLabel *Label11;
    TEdit *SAEdit;
    TEdit *PEdit;
    TLabel *Label12;
    TEdit *DEdit;
    TLabel *Label13;
    TEdit *GEdit;
    TLabel *Label14;
    TEdit *LEdit;
    TLabel *Label15;
    TEdit *NEdit;
    TLabel *Label16;
    TLabel *Label17;
    TEdit *GCodeHeaderEdit;
    TEdit *GCodeFooterEdit;
    TLabel *Label18;
    TMenuItem *N3;
    TMenuItem *ArcCentreDefinition1;
    TMenuItem *Absolute1;
    TMenuItem *N4;
    TMenuItem *CP11;
    TMenuItem *P1C1;
    TMenuItem *CP21;
    TMenuItem *P2C1;
    TMenuItem *ShowG9011;
    TStatusBar *StatusBar1;
    TPrintDialog *PrintDialog1;
    TMenuItem *Print1;
    TMenuItem *N5;
    TMenuItem *ThreadFit1;
    TMenuItem *ExactSize1;
    TMenuItem *CloseFit1;
    TMenuItem *MediumFit1;
    TMenuItem *FreeFit1;
    TMenuItem *ThreadDirection1;
    TMenuItem *RightHand1;
    TMenuItem *LeftHand1;
    TMenuItem *N6;
    TMenuItem *ClimbMill1;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall Exit1Click(TObject *Sender);
    void __fastcall File1Click(TObject *Sender);
    void __fastcall Save1Click(TObject *Sender);
    void __fastcall Copy1Click(TObject *Sender);
    void __fastcall SelectAll1Click(TObject *Sender);
    void __fastcall Help2Click(TObject *Sender);
    void __fastcall Edit1Click(TObject *Sender);
    void __fastcall Recalculate(TObject *Sender);
    void __fastcall ArcCentreDefinition1Click(TObject *Sender);
    void __fastcall Absolute1Click(TObject *Sender);
    void __fastcall ShowG9011Click(TObject *Sender);
    void __fastcall StatusBar1Hint(TObject *Sender);
    void __fastcall Print1Click(TObject *Sender);
    void __fastcall ThreadFit1Click(TObject *Sender);
    void __fastcall ExactSize1Click(TObject *Sender);
    void __fastcall ThreadDirection1Click(TObject *Sender);
    void __fastcall RightHand1Click(TObject *Sender);
    void __fastcall ClimbMill1Click(TObject *Sender);
private:	// User declarations
    //Persistant Tool definitions taken from .ini file
    double toolD;           //Tool Diameter
    double toolD1;          //Tool Shank Diameter
    double toolL;           //Tool Length from reduced shank to point of cutter
    double toolL1;          //Tool Lower Extension below point of cutter
    int toolN;              //Tool Number
    
    //Work data, made persistant by .ini file
    double CX;              //Centre X position
    double CY;              //Centre Y Position
    double CZ;              //Centre X position
    double D;               //Work diameter
    double F;               //Feed Rate
    double G;               //Gap to bottom of tool
    double L;               //Length of thread
    int N;                  //Number of starts in thread
    double P;               //Pitch of thread
    double SA;              //Start angle of first thread
    TCentreType CentreType; //Incremental definition type
    bool showG90point1;

    //gcode header & footer
    AnsiString GCodeHeader;
    AnsiString GCodeFooter;

    //Thread fit and direction of thread
    TFitType ThreadFit;
    TThreadDir ThreadDirection;
    bool ClimbMill;

    void __fastcall UpdateEditBoxes(void);
    void __fastcall UpdateVariables(void);

    bool recalconchange;    //says whether a g code re-calculate should
                            //take place on a change of the text.
    void __fastcall SetRecalculationStatus(bool status);
public:		// User declarations
    __fastcall TIntForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TIntForm *IntForm;
//---------------------------------------------------------------------------
#endif
